/* 
 * File:   rsuk.h
 * Author: Michal Hucik <hucik@ordoz.com>
 *
 * Created on 29. května 2019, 10:52
 * 
 * 
 * ----------------------------- License -------------------------------------
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * ---------------------------------------------------------------------------
 */


#ifndef RSUK_H
#define RSUK_H

#ifdef __cplusplus
extern "C" {
#endif

#include "gdgnet.h"

#define RSUK_LOC_WIDTH  152

    extern int rsuk_get_loc_x ( int rs_loc_x );
    extern int rsuk_get_loc_y ( int rs_loc_y );

    extern int rsuk_get_rs_loc_x ( int loc_x );
    extern int rsuk_get_rs_loc_y ( int loc_y );

    extern int rsuk_get_rs_block_from_rs_loc ( int rs_loc_x, int rs_loc_y );
    extern int rsuk_get_rs_block_from_loc ( int loc_x, int loc_y );
    extern void rsuk_get_loc_from_rs_block ( int block, int *loc_x, int *loc_y );

    extern st_GDGPARTSALL* rsuk_gdgparts_init ( st_GDGELEMENTSALL *elmall, const char *filepath );
    extern st_GDGNETSALL* rsuk_gdgnets_init ( st_GDGELEMENTSALL *elmall, const char * filepath );
    
    extern void rsuk_compare_parts ( st_GDGPARTSALL *spice_partall, st_GDGPARTSALL *rsuk_partall );
    extern void rsuk_compare_netlist ( st_GDGPARTSALL *spice_partall, st_GDGPARTSALL *rsuk_partall, gboolean check_all_ppins );

#ifdef __cplusplus
}
#endif

#endif /* RSUK_H */

