/* 
 * File:   vhdl_optimized_cb.c
 * Author: Michal Hucik <hucik@ordoz.com>
 *
 * Created on 28. května 2019, 8:24
 * 
 * 
 * ----------------------------- License -------------------------------------
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * ---------------------------------------------------------------------------
 */

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <glib.h>

#include "gdgelement.h"
#include "gdgpart.h"
#include "gdgnet.h"
#include "vhdl.h"


char* vhdl_optimized_F101_NOT_NOT_cb ( void *ptr ) {
    st_VHDL_CBDATA *cbdata = ptr;
    GString *str = g_string_new ( "" );

    if ( cbdata->type == VHDL_OPTIMIZED_CBTYPE_INSTANCE ) {
        st_GDGPART *part = cbdata->part;
        const char *net_prefix = cbdata->net_prefix;

        char *signame_in = vhdl_create_signame ( net_prefix, part->netpin[0] );
        char *signame_out = vhdl_create_signame ( net_prefix, part->netpin[1] );
        char *signame_out2 = vhdl_create_signame ( net_prefix, part->netpin[2] );
        g_string_append_printf ( str, "\t%s <= %s;\n", signame_out, signame_in );
        g_string_append_printf ( str, "\t%s <= NOT %s;\n", signame_out2, signame_in );
        g_free ( signame_in );
        g_free ( signame_out );
        g_free ( signame_out2 );
    };
    return g_string_free ( str, FALSE );
}
